<template>
    <q-page padding>
        <q-list bordered>
            <q-item
                v-for="(item, index) of queueManager.Queue"
                :key="`ìtem-${index}`"
            >
                <q-item-section avatar>
                    <q-img
                        :src="item.info.thumbnailUrl"
                        spinner-color="primary"
                        spinner-size="82px"
                    />
                </q-item-section>
                <q-item-section class="item-link">{{
                    item.info.title || 'Unknown title'
                }}</q-item-section>
                <q-item-section>{{
                    item.info.statusText || 'Waiting for status...'
                }}</q-item-section>
                <q-item-section v-if="item.isInProgress || item.isReady">
                    <q-btn
                        flat
                        color="primary"
                        label="Stop"
                        @click="item.Cancel()"
                    />
                </q-item-section>

                <q-item-section v-if="item.isStopped"
                    ><q-btn
                        flat
                        color="primary"
                        label="Resume"
                        @click="item.Resume()"
                    />
                </q-item-section>
                <q-item-section v-if="!item.isInProgress">
                    <q-btn
                        flat
                        color="primary"
                        label="Remove"
                        @click="() => removeItem(item.id)"
                    />
                </q-item-section>
            </q-item>
        </q-list>
    </q-page>
</template>

<script lang="ts">
import Vue from 'vue';
import * as library from 'videopiper2.app.library';
import { log } from 'console';
class QueuePageData {
    queueManager = library.QueueManager;
}
export default Vue.extend({
    data() {
        console.log(library);

        const data = new QueuePageData();
        log('Items in queue');
        log(data.queueManager.getQueueCount());
        return data;
    },
    methods: {
        removeItem(id: number) {
            library.QueueManager.removeItem(id);
            this.$forceUpdate();
        }
    }
});
</script>

<style lang="scss" scoped></style>
